import java.awt.*;

public class DrawingSeaplanePortholes {
    private PortholesCount _portholesCount;

    public PortholesCount getPortholesCount() {
        return _portholesCount;
    }
    public void setPortholesCount(int amount){
        if(PortholesCount.contains(amount)) {
            _portholesCount = PortholesCount.getNumber(amount);
        }
    }

    public void drawSeaplanePortholes(Graphics g, Color color, float startPosX, float startPosY) {
        Graphics2D g2d = (Graphics2D) g;
        g2d.setStroke(new BasicStroke(1));
        int distanceBetweenPortholes = (getPortholesCount().enumNumber == 20) ? 7 : 20 - getPortholesCount().enumNumber / 2;

        for (int i = 0; i < getPortholesCount().enumNumber; i++) {
            g2d.setColor(color);
            int posX = (int)(startPosX + i * distanceBetweenPortholes);
            drawPortholeBundle(g2d, posX, (int)startPosY + 5);
        }
    }

    private void drawPortholeBundle(Graphics2D g2d, int posX, int posY) {
        g2d.fillOval(posX + 10, posY + 6, 5, 5); // Рисуем иллюминатор
        g2d.setColor(Color.BLACK);
        g2d.drawOval(posX + 10, posY + 6, 5, 5); // Рисуем границу иллюминатора
    }
}
