import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

public class FormSeaplane {
    protected DrawingSeaplane _drawningSeaplane = new DrawingSeaplane();
    JPanel PanelWrapper;
    private JPanel PictureBox;
    private JButton buttonCreate;
    private JButton buttonRight;
    private JButton buttonLeft;
    private JButton buttonDown;
    private JButton buttonUp;

    private List<JComponent> controls;
    public FormSeaplane() {
        buttonUp.setName("buttonUp");
        buttonDown.setName("buttonDown");
        buttonLeft.setName("buttonLeft");
        buttonRight.setName("buttonRight");

        InitializeControlsRepaintList();

        buttonCreate.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                _drawningSeaplane = new DrawingSeaplane();
                Random random = new Random();
                _drawningSeaplane.Init(random.nextInt(30, 100),
                        random.nextInt(100, 500),
                        new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                        new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                        random.nextBoolean(), random.nextBoolean() );
                _drawningSeaplane.setPictureSize(PictureBox.getWidth(), PictureBox.getHeight());
                _drawningSeaplane.setPosition(random.nextInt(35, 100),
                        random.nextInt(35, 100));
                Draw();

            }
        });
        ActionListener buttonMoveClickedListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String buttonName = ((JButton) e.getSource()).getName();
                boolean result = false;

                switch (buttonName) {
                    case "buttonUp": {
                        result = _drawningSeaplane.moveTransport(DirectionType.Up);
                    }
                    break;
                    case "buttonDown": {
                        result = _drawningSeaplane.moveTransport(DirectionType.Down);
                    }
                    break;
                    case "buttonLeft": {
                        result = _drawningSeaplane.moveTransport(DirectionType.Left);
                    }
                    break;
                    case "buttonRight": {
                        result = _drawningSeaplane.moveTransport(DirectionType.Right);
                    }
                    break;

                };

                if (result) {
                    Draw();
                };
            };
        };
        buttonRight.addActionListener(buttonMoveClickedListener);
        buttonDown.addActionListener(buttonMoveClickedListener);
        buttonLeft.addActionListener(buttonMoveClickedListener);
        buttonUp.addActionListener(buttonMoveClickedListener);

    }
    private void Draw() {
        if (_drawningSeaplane.EntitySeaplane() == null) {
            return;
        }
        Graphics g = PictureBox.getGraphics();
        g.setColor(PictureBox.getBackground());
        g.fillRect(0,0, PictureBox.getWidth(), PictureBox.getHeight());
        _drawningSeaplane.drawTransport(g);

        RepaintControls();
    }
    private void RepaintControls() {
        for (JComponent control : controls) {
            control.repaint();
        }
    }

    private void InitializeControlsRepaintList() {
        controls = new LinkedList<>();
        controls.add(buttonCreate);
        controls.add(buttonUp);
        controls.add(buttonDown);
        controls.add(buttonLeft);
        controls.add(buttonRight);
    }
}
